import * as React from 'react';
import Animated from 'react-native-reanimated';
import { Props as HeaderContainerProps } from '../Header/HeaderContainer';
import { Route, Layout, HeaderMode, NavigationProp, HeaderScene, SceneDescriptorMap } from '../../types';
declare type ProgressValues = {
    [key: string]: Animated.Value<number>;
};
declare type Props = {
    mode: 'card' | 'modal';
    navigation: NavigationProp;
    descriptors: SceneDescriptorMap;
    routes: Route[];
    openingRoutes: string[];
    closingRoutes: string[];
    onGoBack: (props: {
        route: Route;
    }) => void;
    onOpenRoute: (props: {
        route: Route;
    }) => void;
    onCloseRoute: (props: {
        route: Route;
    }) => void;
    getPreviousRoute: (props: {
        route: Route;
    }) => Route | undefined;
    getGesturesEnabled: (props: {
        route: Route;
    }) => boolean;
    renderHeader: (props: HeaderContainerProps) => React.ReactNode;
    renderScene: (props: {
        route: Route;
    }) => React.ReactNode;
    headerMode: HeaderMode;
    onPageChangeStart?: () => void;
    onPageChangeConfirm?: () => void;
    onPageChangeCancel?: () => void;
};
declare type State = {
    routes: Route[];
    descriptors: SceneDescriptorMap;
    scenes: HeaderScene<Route>[];
    progress: ProgressValues;
    layout: Layout;
    floatingHeaderHeights: {
        [key: string]: number;
    };
};
export default class Stack extends React.Component<Props, State> {
    static getDerivedStateFromProps(props: Props, state: State): {
        routes: Route[];
        scenes: (HeaderScene<Route> | {
            route: Route;
            previous: Route;
            descriptor: import("../../types").SceneDescriptor | undefined;
            progress: {
                current: Animated.Value<number>;
                next: Animated.Value<number> | undefined;
                previous: Animated.Value<number> | undefined;
            };
        })[];
        progress: ProgressValues;
        descriptors: SceneDescriptorMap;
        floatingHeaderHeights: {
            [key: string]: number;
        };
    } | null;
    state: State;
    private handleLayout;
    private handleFloatingHeaderLayout;
    private handleTransitionStart;
    private handleTransitionEnd;
    render(): JSX.Element;
}
export {};
