import * as React from 'react';
import { NavigationProp, NavigationStackConfig, Route, SceneDescriptorMap } from '../../types';
declare type Props = {
    navigation: NavigationProp;
    descriptors: SceneDescriptorMap;
    navigationConfig: NavigationStackConfig;
    onPageChangeStart?: () => void;
    onPageChangeConfirm?: () => void;
    onPageChangeCancel?: () => void;
    screenProps?: unknown;
};
declare type State = {
    routes: Route[];
    opening: string[];
    closing: string[];
    replacing: string[];
    descriptors: SceneDescriptorMap;
};
declare class StackView extends React.Component<Props, State> {
    static getDerivedStateFromProps(props: Readonly<Props>, state: Readonly<State>): {
        routes: Route[];
        descriptors: SceneDescriptorMap;
        opening?: undefined;
        closing?: undefined;
        replacing?: undefined;
    } | {
        routes: Route[];
        opening: string[];
        closing: string[];
        replacing: string[];
        descriptors: SceneDescriptorMap;
    };
    state: State;
    private getGesturesEnabled;
    private getPreviousRoute;
    private renderScene;
    private renderHeader;
    private handleTransitionComplete;
    private handleGoBack;
    private handleOpenRoute;
    private handleCloseRoute;
    render(): JSX.Element;
}
export default StackView;
